; ------------------------------------------------------
; Text 2D
; Copyright (c) 2005, Franck Charlet
; All rights reserved.
; ------------------------------------------------------
; buildblock RELEASE
;  CAPT %5\Release.bat
; buildblockend
; buildblock DEBUG
;  CAPT %5\Debug.bat
; buildblockend

; ------------------------------------------------------
; Constants
SCREEN_WIDTH     equ  800
SCREEN_HEIGHT    equ  600
SCREEN_BPP       equ  32

; ------------------------------------------------------
; Includes
      include  ..\Common_Src\FrameWork.asm
      include  ..\Common_Src\Fonts.asm

; ------------------------------------------------------
; Variables
;lFont      dd  0
trirot   dd 0.74
qrot     dd -0.93
rtri     dd 0.0
rquad    dd 0.0

; ------------------------------------------------------
; Name: Initialize()
; Desc: Perform the various initializations
Initialize    proc

      invoke  glClearDepth, CDBL(1.0)
      invoke  glHint, GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST
      invoke  glClearColor, 0, 0, 0, CFLT(1.0)
      invoke  glEnable, GL_NORMALIZE
;      invoke  glEnable, GL_CULL_FACE

      ; Create the fonts
;      invoke  Create_Font_Bitmap, CSTR("Times New Roman"), 72, FW_NORMAL
;     mov  lFont,eax
;      mov  eax, TRUE
      ret
Initialize    endp

; ------------------------------------------------------
; Name: Deinitialize()
; Desc: Free allocated resources
Deinitialize    proc
;      invoke  Destroy_Font, lFont
      ret
Deinitialize    endp

; ------------------------------------------------------
; Name: Update()
; Desc: Update the scene
Update      proc  FrameRate:real4

      fld rtri
      fadd trirot
      fstp rtri
      fld rquad
      fadd qrot
      fstp rquad
      ; Update scene here
      invoke  DInput_Get_Key, DIK_ESCAPE
      test  eax, eax
      jz  Esc_Pressed
      invoke  Terminate_Application
Esc_Pressed:    ret
Update      endp

; ------------------------------------------------------
; Name: Draw()
; Desc: Draw the scene
Draw      proc

 invoke  glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT

 invoke  glLoadIdentity
 invoke  glTranslatef, CFLT(-1.5), CFLT(0.0), CFLT(-6.0)
 invoke  glRotatef, rtri,CFLT(0.0), CFLT(1.0), CFLT(0.0)
 invoke  glBegin, GL_TRIANGLES
 invoke  glColor3f,  CFLT(1.0), CFLT(1.0), CFLT(0.0) ; RGB Floats 0.0 to 1.0
 invoke  glVertex3f, CFLT(0.0), CFLT(1.0), CFLT(0.0)
 invoke  glColor3f,  CFLT(0.0), CFLT(1.0), CFLT(1.0)
 invoke  glVertex3f, CFLT(-1.0), CFLT(-1.0), CFLT(0.0)
 invoke  glColor3f,  CFLT(1.0), CFLT(0.0), CFLT(1.0)
 invoke  glVertex3f, CFLT(1.0), CFLT(-1.0), CFLT(0.0)
 invoke  glEnd

 invoke  glLoadIdentity
 invoke  glTranslatef, CFLT(1.5), CFLT(0.0), CFLT(-6.0)
 invoke  glRotatef, rquad, CFLT(1.0), CFLT(0.0), CFLT(0.0)
 invoke  glBegin, GL_QUADS
 invoke  glColor3f,  CFLT(1.0), CFLT(0.0), CFLT(0.0)
 invoke  glVertex3f, CFLT(-1.0), CFLT(1.0), CFLT(0.0)
 invoke  glColor3f,  CFLT(0.0), CFLT(1.0), CFLT(0.0)
 invoke  glVertex3f, CFLT(-1.0), CFLT(-1.0), CFLT(0.0)
 invoke  glColor3f,  CFLT(1.0), CFLT(1.0), CFLT(0.0)
 invoke  glVertex3f, CFLT(1.0), CFLT(-1.0), CFLT(0.0)
 invoke  glColor3f,  CFLT(1.0), CFLT(0.0), CFLT(1.0)
 invoke  glVertex3f, CFLT(1.0), CFLT(1.0), CFLT(0.0)
 invoke  glEnd

      xor eax,eax
      ret
Draw      endp

end start